# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.paging import Paged


class ResourceSkuPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ResourceSku <azure.mgmt.datamigration.models.ResourceSku>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ResourceSku]'}
    }

    def __init__(self, *args, **kwargs):

        super(ResourceSkuPaged, self).__init__(*args, **kwargs)
class AvailableServiceSkuPaged(Paged):
    """
    A paging container for iterating over a list of :class:`AvailableServiceSku <azure.mgmt.datamigration.models.AvailableServiceSku>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[AvailableServiceSku]'}
    }

    def __init__(self, *args, **kwargs):

        super(AvailableServiceSkuPaged, self).__init__(*args, **kwargs)
class DataMigrationServicePaged(Paged):
    """
    A paging container for iterating over a list of :class:`DataMigrationService <azure.mgmt.datamigration.models.DataMigrationService>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[DataMigrationService]'}
    }

    def __init__(self, *args, **kwargs):

        super(DataMigrationServicePaged, self).__init__(*args, **kwargs)
class ProjectTaskPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ProjectTask <azure.mgmt.datamigration.models.ProjectTask>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ProjectTask]'}
    }

    def __init__(self, *args, **kwargs):

        super(ProjectTaskPaged, self).__init__(*args, **kwargs)
class ProjectPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Project <azure.mgmt.datamigration.models.Project>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Project]'}
    }

    def __init__(self, *args, **kwargs):

        super(ProjectPaged, self).__init__(*args, **kwargs)
class QuotaPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Quota <azure.mgmt.datamigration.models.Quota>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Quota]'}
    }

    def __init__(self, *args, **kwargs):

        super(QuotaPaged, self).__init__(*args, **kwargs)
class ServiceOperationPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ServiceOperation <azure.mgmt.datamigration.models.ServiceOperation>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ServiceOperation]'}
    }

    def __init__(self, *args, **kwargs):

        super(ServiceOperationPaged, self).__init__(*args, **kwargs)
class ProjectFilePaged(Paged):
    """
    A paging container for iterating over a list of :class:`ProjectFile <azure.mgmt.datamigration.models.ProjectFile>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ProjectFile]'}
    }

    def __init__(self, *args, **kwargs):

        super(ProjectFilePaged, self).__init__(*args, **kwargs)
